%% TD3 - Localisation et Navigation de Robots
%%
%% Exercice 2: Utilisation du filtre de Kalman étendu (EKF) pour la localisation et cartographie
%% a) Estimation de la position d'un robot

clear
close all
clc 

% Créer un véhicule "veh" avec une matrice de covariance odométrique S
S = diag([0.1, 0.5*pi/180].^2);
veh = Vehicle(S);
 
% Ajouter un pilote avec une trajectoire aléatoire 
% (vitesse le long de la trajctoire: 2m/s. Par défaut: 1 m/s)
veh.add_driver(RandomPath(20, 2));

% Créer un filtre de Kalman avec une covariance estimée  
% Vest et une covariance initiale de l'état P0 
Vest = 0.99*S;
P0 = 1e-3*eye(3);
ekf = EKF(veh, Vest, P0);
 
% Exécuter le filtre pour N pas de temps
N = 1000;
ekf.run(N);
 
% Afficher le chemin du véhicule, superposer le chemin estimé, 
% et ajouter des ellipses d'incertitude tous les 10 pas de temps
hold on
veh.plot_xy('b');
ekf.plot_xy('r');
ekf.plot_ellipse(10,'k')
xlabel('x [m]')
ylabel('y [m]')
title({'Ex. 2a: Estimation de la position d''un robot avec l''EKF:','chemin estimé (rouge); chemin vrai (bleu)'})