%% TD3 - Localisation et Navigation de Robots
%%
%% Exercice 2: Utilisation du filtre de Kalman étendu (EKF) pour la localisation et cartographie
%% b) Localisation basée carte

clear
close all
clc 

% Créer un véhicule "veh" avec une matrice de covariance odométrique S
S = diag([0.1, 1*pi/180].^2);
veh = Vehicle(S);
 
% Ajouter un pilote avec une trajectoire aléatoire
veh.add_driver(RandomPath(20, 2));
 
% Créer une carte avec 20 marqueurs
map = Map(20);
 
% Créer un capteur qui utilise la carte et l'état du véhicule pour 
% estimer les primitives du capteur avec une covariance W 
W = diag([0.005, 0.5*pi/180].^2);
sensor = RangeBearingSensor(veh, map, W, 'animate');

% Définir le filtre de Kalman avec les covariances estimées Vest et 
% West et la covariance de l'état initial du véhicule P0, puis exécuter 
% le filtre pour N pas de temps.
Vest = 0.99*S;
West = 0.99*W;
P0 = 1e-3*eye(3);
ekf = EKF(veh, Vest, P0, sensor, West, []);
N = 1000;
ekf.run(N);
 
% Tracer la carte, afficher le chemin du véhicule, superposer 
% le chemin estimé, et ajouter des ellipses d'incertitude 
% tous les 10 pas de temps
map.plot();
veh.plot_xy('b');
ekf.plot_xy('r');
ekf.plot_ellipse(10,'k')
xlabel('x [m]')
ylabel('y [m]')
title('Ex. 2b: Localisation basée carte - chemin estimé (rouge); chemin vrai (bleu)')

% Affichage de l'évolution temporelle de l'erreur d'estimation sur x, y et theta et des bandes 3 sigma (en rose) 
figure(2)
ekf.plot_error()
