%% TD3 - Localisation et Navigation de Robots
%%
%% Exercice 2: Utilisation du filtre de Kalman étendu (EKF) pour la localisation et cartographie
%% c) Création de cartes par un robot 

clear 
close all
clc 

% Créer un véhicule "veh" avec une matrice de covariance odométrique S
S = diag([0.1, 1*pi/180].^2);
veh = Vehicle(S);
 
% Ajouter un pilote avec une trajectoire aléatoire
veh.add_driver(RandomPath(20, 2));

% Créer un capteur qui utilise la carte et l'état du véhicule 
% pour estimer les primitives du capteur avec une covariance W 
map = Map(20);
W = diag([0.005, 0.5*pi/180].^2);
sensor = RangeBearingSensor(veh, map, W,'animate');
 
% Définir le filtre de Kalman avec la covariance estimée West 
% et un véhicule "parfait" (pas de covariance, []) puis exécuter 
% le filtre pour N pas de temps.
West = 0.9*W;
ekf = EKF(veh, [], [], sensor, West, []);
N = 1000;
ekf.run(N);
 
% Tracer la carte et superposer les ellipses d'incertitude 3 sigma estimées 
map.plot();
ekf.plot_map(3, 'k')
xlabel('x [m]')
ylabel('y [m]')
title({'Ex. 2c: Création de cartes par un robot avec l''EKF:','balise estimée (croix); balise vraie (losange)'})