%% TD3 - Localisation et Navigation de Robots
%%
%% Exercice 2: Utilisation du filtre de Kalman étendu (EKF) pour la localisation et cartographie
%% d) Localisation et cartographie simultanées (SLAM) 

clear
close all
clc  
 
% Créer un véhicule "veh" avec une matrice de covariance odométrique S
S = diag([0.1, 1*pi/180].^2);
veh = Vehicle(S);

% Ajouter un pilote avec une trajectoire aléatoire
veh.add_driver(RandomPath(20, 2));
 
% Créer une carte avec 20 marqueurs 
map = Map(20);
 
% Créer un capteur qui utilise la carte et l'état du véhicule 
% pour estimer les primitives du capteur avec une covariance W 
W = diag([0.001, 0.1*pi/180].^2);
sensor = RangeBearingSensor(veh, map, W, 'animate');
 
% Définir le filtre de Kalman avec les covariances estimées Vest 
% et West et la covariance de l'état initial du véhicule P0, 
% puis exécuter le filtre pour N pas de temps pour estimer 
% l'état du véhicule à chaque pas de temps et la carte.
Vest = 0.99*S;
P0 = 1e-4*eye(3);
ekf = EKF(veh, Vest, P0, sensor, W, []);
N = 1000;
ekf.run(N);
 
% Tracer la carte, afficher le chemin du véhicule, superposer 
% le chemin estimé, et ajouter des ellipses d'incertitude tous 
% les 10 pas de temps
map.plot();
ekf.plot_map(3, 'k')
veh.plot_xy('b');
ekf.plot_xy('r');
ekf.plot_ellipse(10, 'k')
xlabel('x [m]')
ylabel('y [m]')
title({'Ex. 2d: EKF SLAM - chemin estimé (rouge); chemin vrai (bleu);','balise estimée (croix); balise vraie (losange)'})
% ekf.plot_error(3,'k')
